﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _1070773
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        BindingList<BaseOrder> comboData = new BindingList<BaseOrder>();
        BindingList<InvoiceLines> data = new BindingList<InvoiceLines>();
        public RadForm1()
        {
            InitializeComponent();

            for (int i = 0; i < 20; i++)
            {
                var order = new BaseOrder { order = new Order() { Id = i, Name = "Name " + i } };
                comboData.Add(order);
            }

          
            for (int i = 0; i < 10; i++)
            {
                var obj = new InvoiceLines() { Id = i, Index = i, Name = "Name" };


                obj.order = comboData[i].order;
                data.Add(obj);
            }
            radGridView1.DataSource = data;




            var comboColumn = new GridViewComboBoxColumn();
            comboColumn.Name = "CustomOrderColumn";
            comboColumn.Width = 100;
            comboColumn.FieldName = "Order";
            comboColumn.DisplayMember = "order.Name";
            comboColumn.ValueMember = "order";
            comboColumn.DataSource = comboData;

            radGridView1.Columns.Add(comboColumn);
            radGridView1.CellEditorInitialized += RadGridView1_CellEditorInitialized;
        }

        private void RadGridView1_CellEditorInitialized(object sender, GridViewCellEventArgs e)
        {
            RadDropDownListEditor editor = e.ActiveEditor as RadDropDownListEditor;
            if (editor != null)
            {
                var element = editor.EditorElement as RadDropDownListElement;
                element.Filter = FilterItem;
            }
        }
        private bool FilterItem(RadListDataItem item)
        {
            var orders = data.Select(x => x.order);
            var currentOrder = ((BaseOrder)item.DataBoundItem).order;

            if (orders.Contains(currentOrder))
            {
                return false;
            }
            return true;
        }
    }
    class BaseOrder
    {
        public Order order { get; set; }

    }
    class MyEditor : RadDropDownListEditor
    {
        public override object Value
        {
            get
            {

                return base.Value;
            }

            set
            {
                base.Value = value;
            }
        }
    }

    class InvoiceLines
    {
        public int Id { get; set; }
        public int Index { get; set; }
        public string Name { get; set; }

        public Order order { get; set; }


    }
    class Order : IComparable
    {
        public int Id { get; set; }
        public string Name { get; set; }

        public int CompareTo(object obj)
        {
            return Name.CompareTo(((Order)obj).Name);
        }

        public override string ToString()
        {
            return Name;
        }
    }
}
